DEFINE VARIABLE hWebService AS HANDLE NO-UNDO.
DEFINE VARIABLE hgetCustOrdersObj AS HANDLE NO-UNDO.
DEFINE VARIABLE cResult AS CHARACTER NO-UNDO.
DEFINE VARIABLE iCustNum AS INTEGER EXTENT 2 NO-UNDO.

{dsCustOrd.i}
{ErrorHandlers.i}


CREATE SERVER hWebService.

hWebService:CONNECT("-WSDL 'http://localhost:8080/wsa/wsa1/wsdl?targetURI=urn:getCustOrders'") NO-ERROR.
IF NOT hWebService:CONNECTED() THEN DO:
    RUN HandleConnectError.
    RUN cleanup.
    LEAVE.
END.


RUN getCustOrdersObj SET hgetCustOrdersObj ON hWebService NO-ERROR.
IF NOT VALID-HANDLE(hgetCustOrdersObj) THEN
DO:
    RUN HandlePortError.
    RUN cleanup.
    LEAVE.
END.


iCustNum[1] = 1.
iCustNum[2] = 10.

/* Procedure invocation of getCustOrders operation. */
RUN getCustOrders IN hgetCustOrdersObj(INPUT iCustNum, 
                                       OUTPUT cResult, 
                                       OUTPUT DATASET dsCustOrd) NO-ERROR.

IF ERROR-STATUS:ERROR THEN
DO:
    RUN HandleWSCallError.
    RUN cleanup.
    LEAVE.
END.

FOR EACH ttCust:
    DISPLAY ttCust.
END.

FOR EACH ttOrder:
    DISPLAY ttOrder.
END.


RUN cleanup.

/* clean up */
PROCEDURE cleanup:
    IF VALID-HANDLE(hgetCustOrdersObj) THEN DELETE OBJECT hgetCustOrdersObj.
    IF hWebService:CONNECTED() THEN hWebService:DISCONNECT().
    IF VALID-HANDLE(hWebService) THEN DELETE OBJECT hWebService.
END PROCEDURE.

